Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::InetWvOut Class Reference

STK internet streaming output class. More...

`#include <InetWvOut.h>`

Inheritance diagram for stk::InetWvOut:

## Public Member Functions

| InetWvOut (unsigned long packetFrames=1024)
| Default constructor ... the socket is not instantiated.
| InetWvOut (int port, Socket::ProtocolType protocol=Socket::PROTO_TCP, std::string hostname="localhost", unsigned int nChannels=1, Stk::StkFormat format=STK_SINT16, unsigned long packetFrames=1024)
| Overloaded constructor which opens a network connection during instantiation.
| ~InetWvOut ()
| Class destructor.
void | connect (int port, Socket::ProtocolType protocol=Socket::PROTO_TCP, std::string hostname="localhost", unsigned int nChannels=1, Stk::StkFormat format=STK_SINT16)
| Connect to the specified host and port and prepare to stream nChannels of data in the given data format.
void | disconnect (void)
| If a connection is open, write out remaining samples in the queue and then disconnect.
void | tick (const StkFloat sample)
| Output a single sample to all channels in a sample frame.
void | tick (const StkFrames &frames)
| Output the StkFrames data.
Public Member Functions inherited from stk::WvOut
| WvOut (void)
| Default constructor.
unsigned long | getFrameCount (void) const
| Return the number of sample frames output.
StkFloat | getTime (void) const
| Return the number of seconds of data output.
bool | clipStatus (void)
| Returns `true` if clipping has been detected during output since instantiation or the last reset.
void | resetClipStatus (void)
| Reset the clipping status to `false`.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members

Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK internet streaming output class.

This WvOut subclass can stream data over a network via a TCP or UDP socket connection. The data is converted to big-endian byte order, if necessary, before being transmitted.

InetWvOut supports multi-channel data. It is important to distinguish the tick() method that outputs a single sample to all channels in a sample frame from the overloaded one that takes a reference to an StkFrames object for multi-channel and/or multi-frame data.

This class connects to a socket server, the port and IP address of which must be specified as constructor arguments. The default data type is signed 16-bit integers but any of the defined StkFormats are permissible.

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ InetWvOut()

stk::InetWvOut::InetWvOut | ( | int | port,
|  | Socket::ProtocolType | protocol = Socket::PROTO_TCP,
|  | std::string | hostname = "localhost",
|  | unsigned int | nChannels = 1,
|  | Stk::StkFormat | format = STK_SINT16,
|  | unsigned long | packetFrames = 1024 )

Overloaded constructor which opens a network connection during instantiation.

An StkError is thrown if a socket error occurs or an invalid argument is specified.

## Member Function Documentation

## ◆ connect()

void stk::InetWvOut::connect | ( | int | port,
|  | Socket::ProtocolType | protocol = Socket::PROTO_TCP,
|  | std::string | hostname = "localhost",
|  | unsigned int | nChannels = 1,
|  | Stk::StkFormat | format = STK_SINT16 )

Connect to the specified host and port and prepare to stream nChannels of data in the given data format.

An StkError is thrown if a socket error occurs or an invalid argument is specified.

## ◆ tick() [1/2]

void stk::InetWvOut::tick | ( | const StkFloat | sample | ) |

virtual

Output a single sample to all channels in a sample frame.

An StkError is thrown if an output error occurs. If a socket connection does not exist, the function does nothing (a warning will be issued if STK_DEBUG is defined during compilation).

Implements stk::WvOut.

## ◆ tick() [2/2]

void stk::InetWvOut::tick | ( | const StkFrames & | frames | ) |

virtual

Output the StkFrames data.

An StkError will be thrown if an output error occurs. An StkError will also be thrown if STK_DEBUG is defined during compilation and there is an incompatability between the number of channels in the FileWvOut object and that in the StkFrames object. If a socket connection does not exist, the function does nothing (a warning will be issued if STK_DEBUG is defined during compilation).

Implements stk::WvOut.

The documentation for this class was generated from the following file:

- InetWvOut.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.